CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                              C
C                                U N R E S                                     C
C                                                                              C
C Program to carry out conformational search of proteins in an united-residue  C
C approximation.                                                               C
C                                                                              C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'

#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif

#ifdef MPI
      include 'mpif.h'
#endif
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.REMD'
      include 'COMMON.MD'
      include 'COMMON.SBRIDGE'
cfmc      include 'COMMON.MCMF'
#ifdef MP
      include 'COMMON.INFO'
#endif
#ifdef MPI
      include 'COMMON.SETUP'
#endif
      double precision varia(maxvar)
      double precision hrtime,mintime,sectime
      double precision przes(3),obr(3,3)
      double precision enetb1(max_threadss),coord1(maxvar,max_threadss)
      double precision energy(0:n_ene)
      integer nharp,iharp(4,maxres/3)
      logical non_conv
      logical file_exist
      character*10 nodeinfo
      character*64 text_mode_calc(-2:14) /'test',
     & 'SC rotamer distribution',
     & 'Energy evaluation or minimization',
     & 'Regularization of PDB structure',
     & 'Threading of a sequence on PDB structures',
     & 'Monte Carlo (with minimization) ',
     & 'Energy minimization of multiple conformations',
     & 'Checking energy gradient',
     & 'Entropic sampling Monte Carlo (with minimization)',
     & 'Energy map',
     & 'CSA calculations',
     & ' free - zscore is rm ',
     & 'Focusing MCM','Soft regularization of PDB structure',
     &  'MD','13','REMD'/
      common /srutu/ icall
      logical eof
      character*3 liczba
      external ilen
crc      integer iparent1(2*max_threadss,2*max_threadss),
crc     & nparent2(max_threadss)
      dimension ind(6)
#ifdef MPI
      dimension muster(mpi_status_size)
#endif
#ifdef MP
C Initialize task.
      call init_task
      time00=MPI_WTIME()
      if (me.eq.king)
     & write (iout,*) 'time after openunits',time00-walltime
#else
      call initialize
      call openunits

      write (iout,'(80(1h*)/a/80(1h*))') 
     & 'United-residue force field calculation - serial job.'
#endif
      if (me.eq.king)
     & write(iout,*)'### LAST MODIFIED  6/23/05 7:29PM by czarek'  
      mask_r=.false.
#ifndef ISNAN
c NaNQ initialization
      i=-1
      rr=dacos(100.0d0)
#ifdef WINPGI
      idumm=proc_proc(rr,i)
#else
      call proc_proc(rr,i)
#endif
#endif
      if (me.eq.king) call cinfo
      call parmread
      call read_control
      if (.not.out1file.and.me.ne.king) then
        open(iout,file=outname,status='unknown')
      endif
      if (minim) call read_minim
      if (modecalc.eq.3 .or. modecalc.eq.6) call mcmread
      if (modecalc.eq.12) call read_MDpar
      if (modecalc.eq.14) then 
         call read_MDpar
         call read_REMDpar
      endif
      if (lmuca) call read_muca
      if (modecalc.eq.8) then
       inquire (file="fort.40",exist=file_exist)
       if (.not.file_exist) call csaread
      endif 
cfmc      if (modecalc.eq.10) call mcmfread
      call molread
#ifdef MPI
      if (.not. out1file .or. me.eq.king) then
#endif
      if (nhpb.gt.nss) 
     &write (iout,'(a,i5,a)') "The following",nhpb-nss,
     & " distance constraints have been imposed"
      do i=nss+1,nhpb
        write (iout,'(3i6,f10.5)') i-nss,ihpb(i),jhpb(i),forcon(i)
      enddo
#ifdef MPI
      endif
#endif
#ifdef MPL
      msglen_var=8*(nvar+3)
#endif
      if (me.eq.king .or. .not. out1file) then
       write (iout,'(2a/)') 
     & text_mode_calc(modecalc)(:ilen(text_mode_calc(modecalc))),
     & ' calculation.' 
       if (minim) write (iout,'(a)') 
     &  'Conformations will be energy-minimized.'
       write (iout,'(80(1h*)/)') 
      endif
cd    print *,'MAIN: nnt=',nnt,' nct=',nct,' modecalc=',modecalc
      close(1)
      if (modecalc.eq.-2) then
        call test
      else if (modecalc.eq.12) then
        write (iout,*) "MODECALC",modecalc
        write (iout,*) "Calling hpb_partition"
        call hpb_partition
        write (iout,*) "Calling chainbuild"
        call chainbuild
        write (iout,*) "Calling MD"
        call MD	
      else if (modecalc.eq.14) then
        if (me.eq.king .or. .not. out1file) then       
         write (iout,*) "MODECALC",modecalc
         write (iout,*) "Calling hpb_partition"
        endif
        call hpb_partition
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "Calling chainbuild"
        call chainbuild
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "Calling REMD"
        if (remd_mlist) then 
         call MREMD
        else
         do i=1,nrep
           remd_m(i)=1
         enddo
         call MREMD	
        endif
      else if (modecalc.eq.-1) then
        call check_sc_distr
      else if (modecalc.eq.0) then
        call hpb_partition
        if (indpdb.eq.0) call chainbuild
        icall=1
        call etotal(energy(0))
        etota = energy(0)
        etot =etota
        call enerprint(energy(0))
c         call mol2out(etot,titel(:32))
        call hairpin(.true.,nharp,iharp)
        call secondary2(.true.)
        if (minim) then
crc overlap test
          if (overlapsc) then 
           print *, 'Calling OVERLAP_SC'
           call overlap_sc(fail)
          endif 

          if (searchsc) then 
           call sc_move(2,nres-1,10,1d10,nft_sc,etot)
           print *,'SC_move',nft_sc,etot
           write(iout,*) 'SC_move',nft_sc,etot
          endif 

crc        
         if(dccart)then
           print *, 'Calling MINIM_DC'
#ifdef MPI
           time1=MPI_WTIME()
#endif
           call minim_dc(etot,iretcode,nfun)
         else
          if(indpdb.ne.0) then 
            call bond_regular
            call chainbuild
          endif
          call geom_to_var(nvar,varia)
          print *,'Calling MINIMIZE.'
#ifdef MPL
          IF (MyID.eq.BossID) THEN
#endif
#ifdef MPI
          time1=MPI_WTIME()
#endif
          call minimize(etot,varia,iretcode,nfun)
         endif
          print *,'SUMSL return code is',iretcode,' eval ',nfun
#ifdef MPI
          evals=nfun/(MPI_WTIME()-time1)
#endif
          print *,'# eval/s',evals
          print *,'refstr=',refstr
          call hairpin(.true.,nharp,iharp)
          call secondary2(.true.)
#ifdef MPL
          call free_slaves(nfun,varia)
          
          ELSE
          
          call ergastulum

          ENDIF ! (MyID.eq.BossID)
cd        write (*,*) 'Processor',MyID,' back in MAIN.'
#endif
cd        write (*,'(a,i5,4(/10f8.3))') 'Processor',MyID,' variables:',
cd   &    (phi(i),i=4,nres),(theta(i),i=2,nres),(alph(i),i=2,nres-1),
cd   &    (omeg(i),i=2,nres-1)
          call etotal(energy(0))
          etot = energy(0)
#ifdef MPL
          IF (MyID.eq.BossID) THEN
#endif
          call enerprint(energy(0))


          call intout
          call briefout(0,etot)
          if (refstr) call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
          write (iout,'(a,i3)') 'SUMSL return code:',iretcode
          write (iout,'(a,i20)') '# of energy evaluations:',nfun+1
          write (iout,'(a,f16.3)')'# of energy evaluations/sec:',evals
#ifdef MPL
          ENDIF ! (MyID.eq.BossID)
#endif
        else
          print *,'refstr=',refstr
          if (refstr) call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
          call briefout(0,etot)
        endif
#ifdef MPL
        do i=0,NProcs-1
          Koniec(i)=.true.
        enddo
        if (MyID.eq.BossID .and. outpdb) then
          call pdbout(etot,titel(:32),ipdb)
        endif
        if (MyID.eq.BossID .and. outmol2) then
          call mol2out(etot,titel(:32))
        endif
#else
        if (outpdb) call pdbout(etot,titel(:32),ipdb)
        if (outmol2) call mol2out(etot,titel(:32))
#endif
      else if (modecalc.eq.1) then
        call gen_dist_constr
        call hpb_partition
        call sc_conf
        call intout
#ifdef MPL
        IF (MyID.eq.BossID) THEN
#endif
        call regularize(nct-nnt+1,etot,rms,cref(1,nnt),iretcode)
#ifdef MPL
        call free_slaves(1,varia)
         
        ELSE
          
        call ergastulum

        ENDIF ! (MyID.eq.BossID)
#endif
        call etotal(energy(0))
#ifdef MPL
        IF (MyID.eq.BossID) THEN
#endif
        energy(0)=energy(0)-energy(14)
        etot=energy(0)
        call enerprint(energy(0))
        call intout
        call briefout(0,etot)
        if (outpdb) call pdbout(etot,titel(:32),ipdb)
        if (outmol2) call mol2out(etot,titel(:32))
        if (refstr) call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
        write (iout,'(a,i3)') 'SUMSL return code:',iretcode
#ifdef MPL
        ENDIF ! (MyID.eq.MasterID)
        do i=0,NProcs-1
          Koniec(i)=.true.
        enddo
#endif
      else if (modecalc.eq.2) then
        call hpb_partition
#ifdef MPL
        IF (MyID.eq.BossID) THEN
#endif
        call thread_seq
#ifdef MPL
        call free_slaves(1,varia)
          
        ELSE
          
        call ergastulum

        ENDIF ! (MyID.eq.BossID)
#endif
      else if (modecalc.eq.3 .or. modecalc .eq.6) then
        call hpb_partition
#ifdef MPL
        IF (MyID.eq.BossID) THEN
#endif
        call mcm_setup
        if (minim) then
#ifdef MP
          if (MyID.eq.MasterID) then
            if (modecalc.eq.3) then
              call do_mcm(ipar)
            else
              call entmcm
            endif
          else
#ifdef MPI
            call execute_slave(nodeinfo,iprint)
#endif
          endif
#else
          if (modecalc.eq.3) then
            call do_mcm(ipar)
          else
            call entmcm
          endif
#endif
        else
          call monte_carlo
        endif
#ifdef MPL
        call free_slaves(1,varia)
          
        ELSE
          
        call ergastulum

        ENDIF ! (MyID.eq.BossID)
#endif
#ifdef MPL
        do i=0,NProcs-1
          Koniec(i)=.true.
        enddo
#endif
      elseif (modecalc.eq.4) then
        call hpb_partition
        eof=.false.
#ifdef MPI
      if(me.ne.king) then
       call minim_mcmf
       goto 40
      endif

        close (intin)
        open(intin,file=intinname,status='old')
       write (istat,'(a5,20a12)')"#    ",
     &    (wname(print_order(i)),i=1,nprint_ene)
       if (refstr) then
         write (istat,'(a5,20a12)')"#    ",
     &   (ename(print_order(i)),i=1,nprint_ene),
     &   "ETOT total","RMSD","nat.contact","nnt.contact"        
       else
       write (istat,'(a5,20a12)')"#    ",
     &    (ename(print_order(i)),i=1,nprint_ene),"ETOT total"
       endif

      if(.not.minim) then
        do while (.not. eof)
          read (intin,'(i5)',end=1100,err=1100) iconf
c          print *,iconf
          call read_angles(intin,*11)  
          call geom_to_var(nvar,varia)
          call chainbuild
          write (iout,'(a,i7)') 'Conformation #',iconf
          call etotal(energy(0))
          call briefout(iconf,energy(0))
          call enerprint(energy(0))
          etot=energy(0)
      if (refstr) then 
         call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
         write (istat,'(i5,20(f12.3))') iconf,
     &     (energy(print_order(i)),i=1,nprint_ene),etot,
     &     rms,frac,frac_nn,co
cjlee end
      else
         write (istat,'(i5,16(f12.3))') iconf,
     &     (energy(print_order(i)),i=1,nprint_ene),etot
      endif
        enddo
1100   continue
       goto 1101
      endif

      mm=0
      imm=0
      nft=0
      ene0=0.0d0
      n=0
      iconf=0
c      do n=1,nzsc
      do while (.not. eof)
        mm=mm+1
        if (mm.lt.nodes) then
          read (intin,'(i5)',end=11,err=11) iconf
c          print *,iconf
          call read_angles(intin,*11)
          call geom_to_var(nvar,varia)
          write (iout,'(a,i7)') 'Conformation #',iconf
          n=n+1
         imm=imm+1
c         print *,'sending task to worker ',mm,nvar,nodes
         ind(1)=1
         ind(2)=n
         ind(3)=0
         ind(4)=0
         ind(5)=0
         ind(6)=0
         ene0=0.0d0
         call mpi_send(ind,6,mpi_integer,mm,idint,mpi_comm_world,
     *                  ierr)
         call mpi_send(varia,nvar,mpi_double_precision,mm,
     *                  idreal,mpi_comm_world,ierr)
         call mpi_send(ene0,1,mpi_double_precision,mm,
     *                  idreal,mpi_comm_world,ierr)
c         print *,'task ',n,' sent to worker ',mm,nvar
        else
         call mpi_recv(ind,6,mpi_integer,mpi_any_source,idint,
     *                 mpi_comm_world,muster,ierr)
         man=muster(mpi_source)
c         print *,'receiving result from worker ',man,' (',iii1,iii,')'
         call mpi_recv(varia,nvar,mpi_double_precision, 
     *               man,idreal,mpi_comm_world,muster,ierr)
         call mpi_recv(ene,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
         call mpi_recv(ene0,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
c         print *,'result received from worker ',man,' sending now'

          call var_to_geom(nvar,varia)
          call chainbuild
          call etotal(energy(0))
          iconf=ind(2)
          write (iout,*)
          write (iout,*)
          write (iout,'(a,2i7)') 'Conformation #',iconf,ind(5)

          etot=energy(0)
          call enerprint(energy(0))
          call briefout(it,etot)
c          if (minim) call briefout(it,etot)
      if (refstr) then 
         call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
         write (istat,'(i5,19(f12.3))') iconf,
     &     (energy(print_order(i)),i=1,nprint_ene),etot,
     &     rms,frac,frac_nn,co
      else
        write (istat,'(i5,15(f12.3))') iconf,
     &     (energy(print_order(i)),i=1,nprint_ene),etot
      endif

       imm=imm-1
          read (intin,'(i5)',end=11,err=11) iconf
c          print *,iconf
          call read_angles(intin,*11)
          call geom_to_var(nvar,varia)
          n=n+1
       imm=imm+1
         ind(1)=1
         ind(2)=n
         ind(3)=0
         ind(4)=0
         ind(5)=0
         ind(6)=0
         call mpi_send(ind,6,mpi_integer,man,idint,mpi_comm_world,
     *                  ierr)
         call mpi_send(varia,nvar,mpi_double_precision,man, 
     *                  idreal,mpi_comm_world,ierr)
         call mpi_send(ene0,1,mpi_double_precision,man,
     *                  idreal,mpi_comm_world,ierr)
c         print *,'task ',n,' sent to worker ',man
c         print *,' sumsl iret=',ind(5)
         nf_mcmf=nf_mcmf+ind(4)
         nmin=nmin+1
        endif
      enddo
11    continue
      do j=1,imm
       call mpi_recv(ind,6,mpi_integer,mpi_any_source,idint,
     *               mpi_comm_world,muster,ierr)
       man=muster(mpi_source)
c       print *,'receiving result from worker ',man,' (',iii1,iii,')'
       call mpi_recv(varia,nvar,mpi_double_precision, 
     *               man,idreal,mpi_comm_world,muster,ierr)
       call mpi_recv(ene,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
       call mpi_recv(ene0,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
c        print *,'result received from worker ',man,' (final)'
c       print *,' sumsl iret=',ind(5)

          call var_to_geom(nvar,varia)
          call chainbuild
          call etotal(energy(0))
          iconf=ind(2)
          write (iout,*)
          write (iout,*)
          write (iout,'(a,2i7)') 'Conformation #',iconf,ind(5)

          etot=energy(0)
          call enerprint(energy(0))
c          if (minim) call briefout(it,etot) 
          call briefout(it,etot)
      if (refstr) then 
         call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
        write (istat,'(i5,19(f12.3))') iconf,
     &   (energy(print_order(i)),i=1,nprint_ene),etot,
     &   rms,frac,frac_nn,co
      else
        write (istat,'(i5,15(f12.3))') iconf,
     &   (energy(print_order(i)),i=1,nprint_ene),etot
      endif
       nmin=nmin+1
      enddo
1101  continue
      do i=1, nodes-1
         ind(1)=0
         ind(2)=0
         ind(3)=0
         ind(4)=0
         ind(5)=0
         ind(6)=0
         call mpi_send(ind,6,mpi_integer,i,idint,mpi_comm_world,
     *                  ierr)
      enddo
#else
        close (intin)
        open(intin,file=intinname,status='old')
       write (istat,'(a5,20a12)')"#    ",
     &   (wname(print_order(i)),i=1,nprint_ene)
        write (istat,'("#    ",20(1pe12.4))')
     &   (weights(print_order(i)),i=1,nprint_ene)
       if (refstr) then
       write (istat,'(a5,20a12)')"#    ",
     &   (ename(print_order(i)),i=1,nprint_ene),
     &   "ETOT total","RMSD","nat.contact","nnt.contact"
       else
       write (istat,'(a5,14a12)')"#    ",
     &   (ename(print_order(i)),i=1,nprint_ene),"ETOT total"
       endif
        do while (.not. eof)
          read (intin,'(i5)',end=11,err=11) iconf
c          print *,iconf
          call read_angles(intin,*11)  
          call geom_to_var(nvar,varia)
          call chainbuild
          write (iout,'(a,i7)') 'Conformation #',iconf
          if (minim) call minimize(etot,varia,iretcode,nfun)
          call etotal(energy(0))

          etot=energy(0)
          call enerprint(energy(0))
          if (minim) call briefout(it,etot) 
      if (refstr) then 
        call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
        write (istat,'(i5,18(f12.3))') iconf,
     &   (energy(print_order(i)),i=1,nprint_ene),
     &   etot,rms,frac,frac_nn,co
cjlee end
      else
        write (istat,'(i5,14(f12.3))') iconf,
     &   (energy(print_order(i)),i=1,nprint_ene),etot
      endif
        enddo
   11   continue
#endif
#ifdef MPL
        do i=0,NProcs-1
          Koniec(i)=.true.
        enddo
#endif
      else if (modecalc.eq.5) then
        call hpb_partition
c        do i=2,nres
c          vbld(i)=vbld(i)+ran_number(-0.1d0,0.1d0)
c          if (itype(i).ne.10) 
c     &      vbld(i+nres)=vbld(i+nres)+ran_number(-0.001d0,0.001d0)
c        enddo
        if (indpdb.eq.0) call chainbuild
c        do i=0,nres
c          do j=1,3
c            dc(j,i)=dc(j,i)+ran_number(-0.2d0,0.2d0)
c          enddo
c        enddo
c        do i=1,nres-1
c          if (itype(i).ne.10) then
c            do j=1,3
c              dc(j,i+nres)=dc(j,i+nres)+ran_number(-0.2d0,0.2d0)
c            enddo
c          endif
c        enddo
c        do j=1,3
c          dc(j,0)=ran_number(-0.2d0,0.2d0)
c        enddo
        call chainbuild_cart
        call cartprint
        call intout
        icall=1
        call etotal(energy(0))
        etot = energy(0)
        call enerprint(energy(0))
        print *,'icheckgrad=',icheckgrad
#ifdef MPL
        do i=0,nprocs-1
          koniec(i)=.true.
        enddo
#endif
        goto (10,20,30) icheckgrad
  10    call check_ecartint
        goto 40
  20    call check_cartgrad
        goto 40
  30    call check_eint
      else if (ModeCalc.eq.7) then
C Mapping
        call hpb_partition
        call map_read
        call map
#ifdef MPI
      else if (ModeCalc.eq.8) then
C Conformational Space Annealling programmed by Jooyoung Lee.
C This method works only with parallel machines!
        call hpb_partition
        call together
      else if (modecalc.eq.9) then
        write(iout,*)'Zscore not included in this version'
cfmc      else if (modecalc.eq.10) then
cfmc        write(iout,*)'MCMF BEGIN'
cfmc        print *,'MCMF BEGIN'
cfmc        call hpb_partition
cfmc        do i=1, maxres
cfmc         ibias(i)=0
cfmc        enddo
cfmc        if(bias_mcmf.gt.0.0d0) then
cfmc         lenpre=ilen(prefix)
cfmc         open(ientin,file=prefix(:lenpre)//'.bias')
cfmc         do i=1,nphi
cfmc          read(ientin,*)ii,ibias(i)
cfmc         enddo
cfmc         close(ientin)
cfmc        endif 
cfmc        call mcmf
      else if (modecalc.eq.11) then
        call chainbuild
        call etotal(energy(0))
        call enerprint(energy(0))
        if(.not.lsecondary) then
          write(iout,*) 'Calling secondary structure recognition'
          call secondary2(debug)
        else
          write(iout,*) 'Using secondary structure supplied in pdb'
        endif

        call softreg

        call etotal(energy(0))
        etot=energy(0)
        call enerprint(energy(0))
        call intout
        call briefout(0,etot)
        call secondary2(.true.)
        if (refstr) call rms_nac_nnc(rms,frac,frac_nn,co,.true.)
      else
#endif
        write (iout,'(a)') 'Unknown ModeCalc=',ModeCalc
      endif
  40  continue
#ifdef MP
C Finish task.
      time1=MPI_WTIME()
      if (me.eq.king .or. .not. out1file)then
       write (iout,'(a,i4,a)') 'Processor',MyId,' is finishing work.'
       write (iout,*) 'Total time',time1-walltime,' sec'
      endif
      write (*,'(a,i4,a)') 'Processor',MyId,' is finishing work.'
      write (*,*) 'Total time',time1-walltime,' sec'
      call finish_task
      if (ilen(tmpdir).gt.0) then
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "Moving output files to the parent directory..."
        close(istat)
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "/bin/mv "//statname(:ilen(statname))//" ."
        call system("/bin/mv "//statname(:ilen(statname))//" .")
        close(irest2)
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "/bin/mv "//rest2name(:ilen(rest2name))//" ."
        call system("/bin/mv "//rest2name(:ilen(rest2name))//" .")
        if (mdpdb) then
          close(ipdb)
          if (me.eq.king .or. .not. out1file)
     &     write (iout,*) "/bin/mv "//pdbname(:ilen(pdbname))//" ."
          call system("/bin/mv "//pdbname(:ilen(pdbname))//" .")
        else
          close(icart)
          if (me.eq.king .or. .not. out1file)
     &     write (iout,*) "/bin/mv "//cartname(:ilen(cartname))//" ."
          call system("/bin/mv "//cartname(:ilen(cartname))//" .")
        endif
        if (me.eq.king .or. .not. out1file)
     &   write (iout,*) "/bin/mv "//outname(:ilen(outname))//" ."
        close (iout)
        call system("/bin/mv "//outname(:ilen(outname))//" .")
      endif
C Cleaning up...
      stop 'Bye Bye...'
#else
      call dajczas(tcpu(),hrtime,mintime,sectime)
      stop '********** Program terminated normally.'
#endif
      end
c--------------------------------------------------------------------------
      subroutine rms_nac_nnc(rms,frac,frac_nn,co,lprn)
        implicit real*8 (a-h,o-z)
        include 'DIMENSIONS'
        include 'COMMON.CHAIN'
        include 'COMMON.CONTACTS'
        include 'COMMON.IOUNITS'
        double precision przes(3),obr(3,3)
        logical non_conv,lprn
c        call fitsq(rms,c(1,nstart_seq),cref(1,nstart_sup),nsup,przes,
c     &             obr,non_conv)
c        rms=dsqrt(rms)
        call rmsd(rms)
        call contact(.false.,ncont,icont,co)
        frac=contact_fract(ncont,ncont_ref,icont,icont_ref)
        frac_nn=contact_fract_nn(ncont,ncont_ref,icont,icont_ref)
        if (lprn) write (iout,'(a,f8.3/a,f8.3/a,f8.3/a,f8.3)')
     &    'RMS deviation from the reference structure:',rms,
     &    ' % of native contacts:',frac*100,
     &    ' % of nonnative contacts:',frac_nn*100,
     &    ' contact order:',co

      return
      end      
